-- B1 DEPENDS: AFTER:SP:ATP_A0_CREATE_DB_TYPES AFTER:PT:PROCESS_END
CREATE PROCEDURE ATP_A6_NORM_OILM (
    IN item NVARCHAR(50),
    IN whs NVARCHAR(8),
    IN includePastReceipt TINYINT,
    OUT doc_lines DOC_LINES_VERSIONS,
    OUT result ATP_DATE_QTY)
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER

READS SQL DATA
AS
-- read planned goods receipts from the database
BEGIN
	docline_series = Select "TransType" as "ObjType", "DocEntry", "DocLineNum",
			 TO_DATE("DocDueDate") as "Date",
		    CASE WHEN (("AccumType" = 2 AND ("ActionType" = 2 or "ActionType" = 14) AND "IsNegLnQty" = 'Y' ) OR
		    		   ("AccumType" = 3 AND ("ActionType" = 1 or "ActionType" = 13) AND "IsNegLnQty" = 'N' )) THEN "EffectQty"
		         ELSE - "EffectQty"
		    END AS "Qty"
	From OILM
	Where "ItemCode" = :item and "LocCode" = :whs And
		  "AccumType" in (2,3) and "ActionType" in (1,2,13,14) And
		  ( ("AccumType" = 2 AND ("ActionType" = 2 or "ActionType" = 14) AND "IsNegLnQty" = 'Y') OR
		    ("AccumType" = 3 AND ("ActionType" = 1 or "ActionType" = 13) AND "IsNegLnQty" = 'N') OR
			("AccumType" = 2 AND ("ActionType" = 1 or "ActionType" = 13) AND "IsNegLnQty" = 'Y') OR
		    ("AccumType" = 3 AND ("ActionType" = 2 or "ActionType" = 14) AND "IsNegLnQty" = 'N') ) AND
		    (:includePastReceipt = 1 OR "DocDueDate" >= Current_date);
	doc_lines = Select "ObjType", "DocEntry", "DocLineNum", 0 as "Version" From :docline_series;
	result = Select "Date", "Qty" From :docline_series;
END;
