-- B1 DEPENDS: AFTER:SP:ATP_A0_CREATE_DB_TYPES AFTER:PT:PROCESS_END

CREATE PROCEDURE ATP_A7_NORM_OSLD ( IN item NVARCHAR(50),
	 IN whs NVARCHAR(8),
	 IN obj_type NVARCHAR (20),
	 IN doc_entry INTEGER,
	 IN doc_line_num INTEGER,
	 IN check_type INTEGER,
	 OUT doc_lines DOC_LINES_VERSIONS,
	 OUT result ATP_DATE_QTY) 
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER
READS SQL DATA 
AS 
BEGIN 
IF :check_type = 1 --check against required quantities

THEN -- Query to get plan issues, which will be needed to subtract when checking against required qty ------
 -- Get the plan issues through posted transactions
 TRANS_REQ = 

SELECT cast("TransType" as nvarchar(20))          as "ObjType", 
       "DocEntry", 
       "DocLineNum", 
       To_date("DocDueDate") as "Date", 
       CASE 
         WHEN ( "TransType" not in ( 163, 165 ) 
                and ( "AccumType" = 2 
                      AND "ActionType" = 1 
                      AND "IsNegLnQty" = 'N' 
                       OR ( "AccumType" = 3 
                            AND "ActionType" = 2 
                            AND "IsNegLnQty" = 'Y' ) ) ) THEN "EffectQty" 
         WHEN ( "TransType" not in ( 163, 165 ) 
                and "AccumType" = 2 
                AND "ActionType" = 2 
                AND "IsNegLnQty" = 'N' 
                 OR ( "AccumType" = 3 
                      AND "ActionType" = 1 
                      AND "IsNegLnQty" = 'Y' ) ) THEN -"EffectQty" 
         --use action=13,14,5 as was line(opposite line to reverse)  
         --use action=2 as should be line  
         WHEN ( "TransType" in ( 165 ) 
                and "AccumType" = 2 
                AND "ActionType" in ( 2 ) 
                AND "IsNegLnQty" = 'N' ) THEN "CIShbQty" 
         WHEN ( "TransType" in ( 165 ) 
                and "AccumType" = 2 
                AND "ActionType" in ( 2 ) 
                AND "IsNegLnQty" = 'Y' ) THEN -"CIShbQty" 
         WHEN ( "TransType" in ( 165 ) 
                and ( ( "AccumType" = 2 
                        AND "ActionType" in ( 13 ) ) 
                       or ( "AccumType" = 0 
                            AND "ActionType" = 5 ) ) 
                AND "IsNegLnQty" = 'N' ) THEN "EffectQty" - "CIShbQty" 
         WHEN ( "TransType" in ( 165 ) 
                and ( "AccumType" = 2 
                      AND "ActionType" in ( 14 ) ) 
                AND "IsNegLnQty" = 'N' ) THEN -( "EffectQty" + "CIShbQty" ) 
         WHEN ( "TransType" in ( 165 ) 
                and ( ( "AccumType" = 2 
                        AND "ActionType" in ( 14 ) ) 
                       or ( "AccumType" = 0 
                            AND "ActionType" = 5 ) ) 
                AND "IsNegLnQty" = 'Y' ) THEN "CIShbQty" - "EffectQty" 
         WHEN ( "TransType" in ( 165 ) 
                and ( "AccumType" = 2 
                      AND "ActionType" in ( 13 ) ) 
                AND "IsNegLnQty" = 'Y' ) THEN "EffectQty" + "CIShbQty" 
         --use action=13,14,5 as was line(opposite line to reverse)  
         --use action=2 as should be line  
         WHEN ( "TransType" in ( 163 ) 
                and "AccumType" = 3 
                AND "ActionType" in ( 2 ) 
                AND "IsNegLnQty" = 'N' ) THEN -"CIShbQty" 
         WHEN ( "TransType" in ( 163 ) 
                and "AccumType" = 3 
                AND "ActionType" in ( 2 ) 
                AND "IsNegLnQty" = 'Y' ) THEN "CIShbQty" 
         WHEN ( "TransType" in ( 163 ) 
                and ( ( "AccumType" = 3 
                        AND "ActionType" in ( 14 ) ) 
                       or ( "AccumType" = 0 
                            AND "ActionType" = 5 ) ) 
                AND "IsNegLnQty" = 'N' ) THEN "EffectQty" + "CIShbQty" 
         WHEN ( "TransType" in ( 163 ) 
                and ( "AccumType" = 3 
                      AND "ActionType" in ( 13 ) ) 
                AND "IsNegLnQty" = 'N' ) THEN "CIShbQty" - "EffectQty" 
         WHEN ( "TransType" in ( 163 ) 
                and ( ( "AccumType" = 3 
                        AND "ActionType" in ( 13 ) ) 
                       or ( "AccumType" = 0 
                            AND "ActionType" = 5 ) ) 
                AND "IsNegLnQty" = 'Y' ) THEN -( "EffectQty" + "CIShbQty" ) 
         WHEN ( "TransType" in ( 163 ) 
                and ( "AccumType" = 3 
                      AND "ActionType" in ( 14 ) ) 
                AND "IsNegLnQty" = 'Y' ) THEN "EffectQty" - "CIShbQty" 
         ELSE -"EffectQty" 
       END                   as "Qty" 
FROM   OILM 
WHERE  "ItemCode" = :item 
       and "LocCode" = :whs 
       and "AccumType" in ( 0, 2, 3 ) 
       and "ActionType" in ( 1, 2, 5, 13, 14 ) 
       and ( ( "AccumType" = 2 
               AND "ActionType" in (1, 13) 
               AND "IsNegLnQty" = 'N' ) 
              OR ( "AccumType" = 3 
                   AND  "ActionType" in (2, 14)
                   AND "IsNegLnQty" = 'Y' ) 
              OR ( "AccumType" = 2 
                   AND "ActionType" in (2, 14)  
                   AND "IsNegLnQty" = 'N' ) 
              OR ( "AccumType" = 3 
                   AND "ActionType" in (1, 13 ) 
                   AND "IsNegLnQty" = 'Y' ) 
              OR ( "AccumType" = 0 AND "ActionType" = 5 ) ) 
              --AND ((part 1 and part 2) or part 3 or part 4)
--part 1 = non-CI docs which need ATP check
--part 2 = part what was copied away part
--part 3 = AP correction reserve invoice
--part 4 = AR correction reserve invoice
       AND ( (( ( ( "TransType" != :obj_type 
				OR "DocEntry" != :doc_entry 
				OR "DocLineNum" != :doc_line_num
				or  "AccumType"!=2 or "ActionType" !=1)  
				 and ( "TransType" != :obj_type 
				OR "DocEntry" != :doc_entry 
				OR "DocLineNum" != :doc_line_num
				or  "AccumType"!=3 or "ActionType" !=2))--these two kinds will need ATP check in non-CI docs
			and "TransType" not in ( 163,
	 165 ) ) --no need to exclude 164/166 since they don't have ATP
	 
	  
		and ( ( "BaseType" != :obj_type --Base fields here are for current line's partially copied part
				OR "BaseAbsEnt" != :doc_entry 
				OR "BaseLine" != :doc_line_num ) 
			and ("BaseType" not in ( 163, 165 )  or "TransType" in ( 164, 166 )) ))
              --no partial copy in CI     
              or (( ( "TransType" != :obj_type 
                       OR "DocEntry" != :doc_entry 
                       OR "DocLineNum" != :doc_line_num 
                       or "AccumType" != 3 ) 
                    and "TransType" = 163 )) 
              or (( ( "TransType" != :obj_type 
                       OR "DocEntry" != :doc_entry 
                       OR "DocLineNum" != :doc_line_num 
                       --keep accumtype=0 as was line(opposite line to reverse)  
                       or "AccumType" != 2 ) 
                    and "TransType" = 165 )) )  
;
 -- Get the plan issues that still waiting for approvement.
 -- When creating a draft that sent for approvement, the required quantity will be insert into OSLD
 WFA_REQ = Select
	 "ObjType",
	 "DocEntry",
	 "DocLineNum",
	 TO_DATE("CfmDate") as "Date",
	 "ReqQty" as "Qty" 
From OSLD 
Where "ReqQty" != 0 
And "ItemCode" = :item 
And "WhsCode" = :whs 
And ("ObjType" != :obj_type 
	OR "DocEntry" != :doc_entry 
	OR "DocLineNum" != :doc_line_num)
;
 docline_series = Select
	 "ObjType",
	 "DocEntry",
	 "DocLineNum",
	 "Date",
	 cast(-"Qty" as decimal(21,6)) as "Qty" 
From :TRANS_REQ 
UNION ALL Select
	 "ObjType",
	 "DocEntry",
	 "DocLineNum",
	 "Date",
	 cast(-"Qty" as decimal(21,6)) as "Qty" 
From :WFA_REQ
;
 doc_lines = Select
	 "ObjType",
	 "DocEntry",
	 "DocLineNum",
	 0 as "Version" 
From :docline_series
;
 Result = Select
	 "Date",
	 cast("Qty" as DECIMAL(21,6)) as "Qty"
From :docline_series
;
ELSEIF :check_type = 2 --check against confirmed quantities

THEN -- ignore confirmations of order line with key (obj_type, doc_entry, doc_line_num)
 docline_series = SELECT
	 "ObjType",
	 "DocEntry",
	 "DocLineNum",
	 TO_DATE("CfmDate") as "Date",
	 cast(-1*"CfmQty" as decimal(21,6)) as "Qty" 
FROM OSLD 
WHERE "ItemCode" = :item 
AND "WhsCode" = :whs 
AND ("ObjType" != :obj_type 
	OR "DocEntry" != :doc_entry 
	OR "DocLineNum" != :doc_line_num)
;
 doc_lines = Select
	 "ObjType",
	 "DocEntry",
	 "DocLineNum",
	 0 as "Version" 
From :docline_series
;
 Result = Select
	 "Date",
	 cast("Qty" as DECIMAL(21,6)) as "Qty"
From :docline_series
;

END 
IF
;

END
;
