CREATE PROCEDURE PreTest_SerialNumber_Stock_Compare_Check() 
					LANGUAGE SQLSCRIPT 
					AS
					common_counter int;
					BEGIN
						select count(*) into common_counter from CINF where "Version" >= 880000;
						if :common_counter > 0 then						
							create column table tblCalcBatch1 as (
     							select "ItemCode", "WhsCode", sum("Quantity") "Qty" from OBTQ group by "ItemCode", "WhsCode"
     						);		

							create column table tblCalcBatch2 as (
 								select "ItemCode", "LocCode", Coalesce(SUM(ABS("StockQty")), 0) - Coalesce(SUM(ABS("DefinedQty")), 0) "Qty"
									from OITL where "DocQty" > 0 and "StockEff" = 1
									and "LogEntry" not in (
										select a."LogEntry" from OITL a inner join OITL b on a."ApplyType" = b."BaseType" and a."ApplyEntry" = b."BaseEntry"
										where a."ManagedBy" = '10000044' and a."StockEff" = 1 and a."ApplyType" not in (17,163,165))
									group by "ItemCode", "LocCode"
    						);			

							create column table tblCalcSerial1 as (
 								select "ItemCode", "WhsCode", sum("Quantity") "Qty"
									from OSRQ group by "ItemCode", "WhsCode"
    						);							


							create column table tblCalcSerial2 as (
	 							select "ItemCode", "LocCode", Coalesce(SUM(ABS("StockQty")), 0) - Coalesce(SUM(ABS("DefinedQty")), 0) "Qty"
									from OITL where "DocQty" > 0 and "StockEff" = 1
									and "LogEntry" not in (
										select a."LogEntry" from OITL a inner join OITL b on a."ApplyType" = b."BaseType" and a."ApplyEntry" = b."BaseEntry"
										where a."ManagedBy" = '10000045' and a."StockEff" = 1 and a."ApplyType" not in (17,163,165))
									group by "ItemCode", "LocCode"
   							);			
							
							select * from (                                 
							-- BATCH
							select count (*) as c							
							from OITW T0 inner join OITM T1 on T1."ItemCode" = T0."ItemCode" and T1."ManBtchNum" = 'Y'
							inner join OWHS t3 on t0."WhsCode" = t3."WhsCode" and t3."DropShip" <> 'Y' 
							left join 
							tblCalcBatch1 on tblCalcBatch1."ItemCode" = t0."ItemCode" and tblCalcBatch1."WhsCode"  = t0."WhsCode"
							left join tblCalcBatch2 on tblCalcBatch2."ItemCode" = t0."ItemCode" and tblCalcBatch2."LocCode"  = t0."WhsCode"
							where T0."OnHand" - Coalesce(tblCalcBatch1."Qty", 0) - Coalesce((tblCalcBatch2."Qty" + Abs(tblCalcBatch2."Qty")) / 2, 0) <> 0 or T0."OnHand" < 0
							union
							-- SERIAL
							select count (*) as c 							
							from OITW T0 inner join OITM T1 on T1."ItemCode" = T0."ItemCode" and T1."ManSerNum" = 'Y'
							inner join OWHS t3 on t0."WhsCode" = t3."WhsCode" and t3."DropShip" <> 'Y' 
							left join tblCalcSerial1 on tblCalcSerial1."ItemCode" = t0."ItemCode" and tblCalcSerial1."WhsCode"  = t0."WhsCode"
							left join tblCalcSerial2 on tblCalcSerial2."ItemCode" = t0."ItemCode" and tblCalcSerial2."LocCode"  = t0."WhsCode"
							where T0."OnHand" - Coalesce(tblCalcSerial1."Qty", 0) - Coalesce((tblCalcSerial2."Qty" + Abs(tblCalcSerial2."Qty")) / 2, 0) <> 0 or T0."OnHand" < 0) a							
							where c > 0;
							
							drop table tblCalcBatch1;
							drop table tblCalcBatch2;
							drop table tblCalcSerial1;
							drop table tblCalcSerial2;
						end if;
					END;
