CREATE VIEW "IMCYC"."SALES_INSTALLMENTS" ( "DOCTYPE", "DOCGROUP", "DOCENTRY", "CARDCODE", "CARDNAME", "BPGROUPCODE", "BPGROUPNAME", "SLPCODE", "SLPNAME", "DOCDATE", "DOCDUEDATE", "TAXDATE", "INSDUEDATE", "SALES", "GROSSPROFIT" ) AS ((((Select 13 as DocType, 'INV' as DocGroup,				
				T0."DocEntry" as DocEntry, 
 				T0."CardCode" as CardCode, T1."CardName" as CardName,
 				T1."GroupCode" as BPGroupCode, T2."GroupName" as BPGroupName,
 				T3."SlpCode" as SlpCode, T3."SlpName" as SlpName,
 				T0."DocDate" as DocDate,
 				T0."DocDueDate" as DocDueDate,
 				T0."TaxDate" as TaxDate,
 				T6."DueDate" as InsDueDate,
				
 				(T6."InsTotal" - T6."VatSum" - T6."TotalExpns" 
 				 + (Case (Select Min(WTLines."Category") From INV5 WTLines Where WTLines."AbsEntry" = T0."DocEntry") 
 					When 'I' Then T6."WTSum"
 					Else 0
 					End)
 				 + T0."DpmAmnt"  * T6."InstPrcnt" / 100 
 				 - T0."RoundDif" * T6."InstPrcnt" / 100) as Sales,
 				
 				(T0."GrosProfit"* T6."InstPrcnt" / 100) as GrossProfit

 
 				From OINV T0 
 				Join OCRD T1 On T0."CardCode" =  T1."CardCode"
 				Join OCRG T2 On T1."GroupCode" = T2."GroupCode"
 				Join OSLP T3 On T0."SlpCode" = T3."SlpCode"
 				Join INV6 T6 On T0."DocEntry" = T6."DocEntry"
 					
 				Where T0."Instance" = 0 
 					And T0."CANCELED" = 'N') UNION ALL (Select 14 as DocType, 'INV' as DocGroup,
 				T0."DocEntry" as DocEntry, 
 				T0."CardCode" as CardCode, T1."CardName" as CardName,
 				T1."GroupCode" as BPGroupCode, T2."GroupName" as BPGroupName,
 				T3."SlpCode" as SlpCode, T3."SlpName" as SlpName,
 				T0."DocDate" as DocDate,
 				T0."DocDueDate" as DocDueDate,
 				T0."TaxDate" as TaxDate,
 				T6."DueDate" as InsDueDate,
 				
 				-(T6."InsTotal" - T6."VatSum" - T6."TotalExpns" 
				  + (Case (Select Min(WTLines."Category") From RIN5 WTLines Where WTLines."AbsEntry" = T0."DocEntry") 
 					When 'I' Then T6."WTSum"
 					Else 0
 					End) 
 				  + T0."DpmAmnt"  * T6."InstPrcnt" / 100 
 				  - T0."RoundDif" * T6."InstPrcnt" / 100) as Sales,
 				
 				-(T0."GrosProfit"* T6."InstPrcnt" / 100) as GrossProfit

 				
 				From ORIN T0 
 				Join OCRD T1 On T0."CardCode" =  T1."CardCode"
 				Join OCRG T2 On T1."GroupCode" = T2."GroupCode"
 				Join OSLP T3 On T0."SlpCode" = T3."SlpCode"
 				Join RIN6 T6 On T0."DocEntry" = T6."DocEntry"
 				Where T0."Instance" = 0 
 					And T0."CANCELED" = 'N'
 					And Not Exists( Select 1 From RIN1 T1 
 									where T1."DocEntry" = T0."DocEntry"
 										And T1."BaseType" = 203))) UNION ALL (Select 165 as DocType, 'INV' as DocGroup,				
				T0."DocEntry" as DocEntry, 
 				T0."CardCode" as CardCode, T1."CardName" as CardName,
 				T1."GroupCode" as BPGroupCode, T2."GroupName" as BPGroupName,
 				T3."SlpCode" as SlpCode, T3."SlpName" as SlpName,
 				T0."DocDate" as DocDate,
 				T0."DocDueDate" as DocDueDate,
 				T0."TaxDate" as TaxDate,
 				T6."DueDate" as InsDueDate,
 				
 				(T6."InsTotal" - T6."VatSum" - T6."TotalExpns" 
 				 + (Case (Select Min(WTLines."Category") From CSI5 WTLines Where WTLines."AbsEntry" = T0."DocEntry") 
 					When 'I' Then T6."WTSum"
 					Else 0
 					End)
 				 + T0."DpmAmnt"  * T6."InstPrcnt" / 100 
 				 - T0."RoundDif" * T6."InstPrcnt" / 100) as Sales,
 				
 				(T0."GrosProfit"* T6."InstPrcnt" / 100) as GrossProfit

 				From OCSI T0 
 				Join OCRD T1 On T0."CardCode" =  T1."CardCode"
 				Join OCRG T2 On T1."GroupCode" = T2."GroupCode"
 				Join OSLP T3 On T0."SlpCode" = T3."SlpCode"
 				Join CSI6 T6 On T0."DocEntry" = T6."DocEntry"
 				Where T0."Instance" = 0)) UNION ALL (Select 166 as DocType, 'INV' as DocGroup,				
				T0."DocEntry" as DocEntry, 
 				T0."CardCode" as CardCode, T1."CardName" as CardName,
 				T1."GroupCode" as BPGroupCode, T2."GroupName" as BPGroupName,
 				T3."SlpCode" as SlpCode, T3."SlpName" as SlpName,
 				T0."DocDate" as DocDate,
 				T0."DocDueDate" as DocDueDate,
 				T0."TaxDate" as TaxDate,
 				T6."DueDate" as InsDueDate,
 				
				(T6."InsTotal" - T6."VatSum" - T6."TotalExpns"
			 	 + (Case (Select Min(WTLines."Category") From CSV5 WTLines Where WTLines."AbsEntry" = T0."DocEntry") 
 					When 'I' Then T6."WTSum"
 					Else 0
 					End) 
 				 + T0."DpmAmnt"  * T6."InstPrcnt" / 100 
 				 - T0."RoundDif" * T6."InstPrcnt" / 100) as Sales,
 				
 				(T0."GrosProfit"* T6."InstPrcnt" / 100) as GrossProfit
				
 				From OCSV T0 
 				Join OCRD T1 On T0."CardCode" =  T1."CardCode"
 				Join OCRG T2 On T1."GroupCode" = T2."GroupCode"
 				Join OSLP T3 On T0."SlpCode" = T3."SlpCode"
 				Join CSV6 T6 On T0."DocEntry" = T6."DocEntry"
 				Where T0."Instance" = 0 
 					And T0."CANCELED" = 'N')) WITH READ ONLY