CREATE PROCEDURE TmSp_BOM_IsFather (IN father nvarchar(50), IN son nvarchar(50) )

LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER
as
	
begin

	DECLARE actualLayer integer;				-- current layer of the tree nodes
	DECLARE newRows integer;			-- number of new nodes
	
	actualLayer := 0;
	newRows := 1;	
	

	-- check for identical fatehr and son
	IF :father = :son THEN 	
 		SELECT 1 FROM dummy;
 		RETURN;
	END IF;


	-- list of reached nodes with the layer where it was found for the first time
	CREATE LOCAL TEMPORARY TABLE #reached ( id nvarchar(50), layer integer);
	DELETE FROM #reached WHERE 1=1;

	-- insert root node id, start with child on layer 0
	INSERT INTO #reached VALUES (:son, :actualLayer);

	-- continu until new layer adds newly discovered nodes
	WHILE (:newRows > 0) 
	DO

		actualLayer := :actualLayer + 1;
		
		INSERT INTO #reached 	-- insert new nodes found on this layer
			SELECT DISTINCT id, :actualLayer 
			FROM 
			(
				SELECT DISTINCT "Father" AS id FROM "ITT1"	
					WHERE "Code"  IN
						(SELECT id FROM #reached WHERE layer = :actualLayer-1)	-- select nodes from previous layer
			
				UNION ALL

				SELECT DISTINCT A."ItemCode" FROM "OWOR" A 
					INNER JOIN "WOR1" B ON A."DocEntry" = B."DocEntry" 
					WHERE B."ItemCode"  IN 
						(SELECT id FROM #reached WHERE layer = :actualLayer-1)	-- select nodes from previous layer
						AND (A."Status" = ('P ') OR A."Status" = ('R ') ) 
			) 	Fathers		
				
			WHERE id  NOT IN ( SELECT id FROM #reached );   -- remove already discovered nodes present in the @reached table  
			
		-- chek if node is present in currently added layer
		SELECT count(*) into newRows FROM #reached WHERE id = :father AND layer = :actualLayer;
		IF :newRows > 0 
		THEN
			DROP TABLE #reached;	
			SELECT 1 FROM dummy;			 
			RETURN;
		END IF;
					
		SELECT count(*) into newRows FROM #reached WHERE layer = :actualLayer;		
	  
	END WHILE;

	-- node not found in any of the layers
	DROP TABLE #reached;	
	SELECT 0 FROM dummy;
		
end;
