-- B1 DEPENDS: BEFORE:PT:CREATE_OBJECTS

CREATE procedure TmSp_UpgradeElectronicInvoiceMX()
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER
AS

table_name   nvarchar(100);
object_abbev nvarchar(100);
action_type  nvarchar(100);
	
isExists     int;
counter      int;
max_count    int;
nextAbsEntry int;
countUDF     int;

sqlStr       nvarchar(4000);
sqlUDF_src   nvarchar(100);
sqlUDF_tgt   nvarchar(100);

BEGIN
	counter   := 0;
	max_count := 3;

	select count(*) into countUDF from CUFD where "TableID" = 'ECM2' and "AliasID" IN ('B1SYS_SignMsg', 'B1SYS_SignDigest');
	IF (:countUDF = 2) THEN
		sqlUDF_tgt := ', "U_B1SYS_SignMsg", "U_B1SYS_SignDigest"';
		sqlUDF_src := ', t0."SignMsg", t0."SignDigest"';
	ELSE
		sqlUDF_tgt := '';
		sqlUDF_src := '';
	END IF;

	-- get autoKey for ECM2
	--    - we do not need check ECM2.AbsEntry, it was not used in MX until now
	select count(*) into isExists from ONNM where "ObjectCode" = '1730000000';
	IF :IsExists <> 0 THEN
		select ifnull("AutoKey", 1) into nextAbsEntry from ONNM where "ObjectCode" = '1730000000';
	ELSE
		nextAbsEntry := 1;		
	END IF;
	nextAbsEntry := nextAbsEntry - 1;

	WHILE (counter < :max_count) DO
		IF :counter = 0 THEN
			table_name   := 'OINV';
			object_abbev := 'IN';
			action_type  := 'D';	-- LAT_DOCUMENT_AR
		ELSEIF :counter = 1 THEN
			table_name   := 'ORIN';
			object_abbev := 'CN';
			action_type  := 'D';	-- LAT_DOCUMENT_AR
		ELSEIF :counter = 2 THEN
			table_name   := 'ODPI';
			object_abbev := 'DT';
			action_type  := 'D';	-- LAT_DOCUMENT_AR
		END IF;

		/*
			OINV.EDocStatus
			'N' New
			'P' Pending
			'S' Sent
			'E' Error
			'C' OK

			ECM2.ActStatus
			'N' New
			'P' Pending
			'E' Error
			'O'	OK
			'S'	Sent
			'R'	Document Error
			'W'	Waiting
			'A'	Authorized
			'I'	In Process
			'J'	Rejected
			'D'	Denied
			'C'	Canceled
			'B'	Aborted
		*/

		sqlStr := '
				 insert into ECM2
				   ("AbsEntry",
				    "Code", "ActType", "ActStatus",
				    "ActEnv", "BPLId", "ObjectID", "ReportID", 
				    "SrcObjType", "SrcObjAbs", "Cancel", 
				    "UserSign", "CreateDate", "CreateTS", "UserSign2", "UpdateDate", "UpdateTS"' || :sqlUDF_tgt || ') 
				 select 
				   ROW_NUMBER() OVER (Order by t0."DocEntry") + ' || CAST(:nextAbsEntry as nvarchar) || ', 
				   ''M'', ''' || :action_type || ''', (CASE WHEN t0."CANCELED" = ''Y'' THEN ''C'' WHEN t0."EDocStatus" = ''C'' THEN ''A'' ELSE t0."EDocStatus" END), 
				   (CASE WHEN t0."EDocTest" = ''Y'' THEN 0 ELSE 1 END), t0."BPLId", ''' || :object_abbev || ' '' || CAST(t0."DocNum" as nvarchar), t0."EDocNum", 
				   t0."ObjType", t0."DocEntry", t0."CANCELED", 
				   t0."UserSign", t0."CreateDate", t0."CreateTS", t0."UserSign2", t0."UpdateDate", t0."UpdateTS"' || :sqlUDF_src || ' 
				 from ' || :table_name || ' t0 
				   inner join NNM1 t1 on t0."Series" = t1."Series"
					left join ecm2 t5 on t5."SrcObjType" = t0."ObjType" and t5."SrcObjAbs" = t0."DocEntry" 
				 where t1."IsDigSerie"  = ''Y''
				   and t0."CANCELED"   IN (''Y'', ''N'')
				   and t0."EDocGenTyp" IN (''G'', ''L'')
				   and t5."AbsEntry" is NULL ';
		Exec(:sqlStr);
		
		sqlStr := ' 
				 insert into ECM3 
				   ("AbsEntry", 
				    "LogNum", "LogType", 
				    "LogMessage", "LogData", 
				    "UserSign", "CreateDate", "CreateTS", "UserSign2", "UpdateDate", "UpdateTS")
				 select 
				   t5."AbsEntry", 
				   1, ''S'',
				   (CASE when "EDocErrCod" IS NULL then '''' ELSE "EDocErrCod" || '': '' || SUBSTRING("EDocErrMsg", 1, 245) END), t0."EDocCntnt", 
				   t0."UserSign", t0."CreateDate", t0."CreateTS", t0."UserSign2", t0."UpdateDate", t0."UpdateTS" 
				 from ' || :table_name || ' t0 
				   inner join NNM1 t1 on t0."Series" = t1."Series"
					left join ecm2 t5 on t5."SrcObjType" = t0."ObjType" and t5."SrcObjAbs" = t0."DocEntry" 
					left join ecm3 t6 on t6."AbsEntry" = t5."AbsEntry" 
				 where t1."IsDigSerie"  = ''Y''
				   and t0."CANCELED"   IN (''Y'', ''N'')
				   and t0."EDocGenTyp" IN (''G'', ''L'')
				   and t6."AbsEntry" is NULL ';
		Exec(:sqlStr);

		counter := :counter + 1;
		select ifnull(max("AbsEntry"), 0) + 1 into nextAbsEntry from ECM2;
	END WHILE;

	update ONNM set "AutoKey" = :nextAbsEntry where "ObjectCode" = '1730000000';  -- for ECM Electronic Communication

END;
