-- B1 DEPENDS: AFTER:PT:CREATE_TABLES_TO_VIEWS

CREATE procedure  _TmSp_BeforeUpdateAppObjLineOINM(IN compVersion nvarchar(40))
language sqlscript
SQL SECURITY INVOKER
AS
obj int;
BEGIN

SELECT count(*) into obj
FROM "PUBLIC".objects 
WHERE object_name = 'TMPIGNOREDUPITEMCODEIGN1'  and schema_name = CURRENT_SCHEMA;
if :obj <> 0 then
	DROP TABLE tmpIgnoreDupItemCodeIGN1;
end if;

SELECT count(*) into obj
FROM "PUBLIC".objects 
WHERE object_name = 'TMPIGNOREDUPITEMCODEIGE1'  and schema_name = CURRENT_SCHEMA;
if :obj <> 0 then
	DROP TABLE tmpIgnoreDupItemCodeIGE1;
end if;

SELECT count(*) into obj
FROM "PUBLIC".objects 
WHERE object_name = 'TMPIGNOREDUPFIFOBACKFLUSHITEMCODE'  and schema_name = CURRENT_SCHEMA;
if :obj <> 0 then
	DROP TABLE tmpIgnoreDupFIFOBackFlushItemCode;
end if;

/*
--Step1: Find all duplicated back flush Items

-- IGN - 1) Precheck before upgrade, handled manualy before the upgrade. 
--       2) Precheck during upgrade to avoid update this rows again wrongly. 
-- Exclude IGN handle of production BOM with duplicate ItemCode.
create global temporary table tmpIgnoreDupItemCodeIGN1(DocEntry int,
															  LineNum int,
															  ItemCode nvarchar(5000),
															  AppObjAbs int);
insert into	tmpIgnoreDupItemCodeIGN1
select		O1."CreatedBy", O1."DocLineNum",
			O1."ItemCode", MIN(O1."AppObjAbs")
from		OINM O1
INNER JOIN	IGN1 O2 
ON			O1."TransType"=59 and O1."ApplObj" IS NOT NULL AND O1."ApplObj"=202 
			AND O1."AppObjType" IS NOT NULL AND O1."AppObjType"='C' AND
			O1."CreatedBy" = O2."DocEntry" AND
			O1."DocLineNum" = O2."LineNum"
INNER JOIN	OIGN O3
ON			O2."DocEntry" = O3."DocEntry" AND
			(
				O3."VersionNum" IS NULL OR
				O3."VersionNum" < :compVersion
			)
INNER JOIN	WOR1 O4 
ON			O2."BaseEntry" = O4."DocEntry" AND
			O1."ItemCode" = O4."ItemCode" AND 
			O4."IssueType" = 'B'
GROUP BY	O1."CreatedBy",O1."DocLineNum",O1."ItemCode"
HAVING		count(1) > 1;

-- IGE - 1) Precheck before upgrade, handled manualy before the upgrade. 
--       2) Precheck during upgrade to avoid update this rows again wrongly. 
-- Exclude IGE handle of production BOM with duplicate ItemCode.
create global temporary column table tmpIgnoreDupItemCodeIGE1(DocEntry int,
															  LineNum int,
															  ItemCode nvarchar(5000),
															  AppObjAbs int);
insert into	tmpIgnoreDupItemCodeIGE1
select		O1."CreatedBy",O1."DocLineNum", 
			O1."ItemCode", MIN(O1."AppObjAbs")
from		OINM O1
INNER JOIN	IGE1 O2 ON
			O1."TransType"=60 and O1."ApplObj" IS NOT NULL AND O1."ApplObj"=202 AND 
			O1."AppObjType" IS NOT NULL AND O1."AppObjType"='C' AND
			O1."CreatedBy" = O2."DocEntry" AND
			O1."DocLineNum" = O2."LineNum" 
INNER JOIN OIGE O3
ON      	O2."DocEntry" = O3."DocEntry" AND
			(
				O3."VersionNum" IS NULL OR
				O3."VersionNum" < :compVersion
			)
INNER JOIN	WOR1 O4 ON
			O2."BaseEntry" = O4."DocEntry" AND
			O1."ItemCode" = O4."ItemCode" AND 
			O4."IssueType" = 'B'
GROUP BY	O1."CreatedBy",O1."DocLineNum",O1."ItemCode"
HAVING		count(1) > 1;


--Step2: Find duplicated back flush FIFO Items
create local temporary table WOR1BackFlushItemCount(DocEntry int,
															ItemCode nvarchar(50),
															BackFlushItemCount int);
															
insert into WOR1BackFlushItemCount
	select "DocEntry", "ItemCode", count(1) -- as "BackFlushItemCount"  
	from WOR1
	where "IssueType" = 'B'
	group by "DocEntry","ItemCode";

create global temporary table OINMBackFlushItemCount(AppObjAbs int,
													ItemCode nvarchar(50),
													BackFlushItemCount int);
insert into OINMBackFlushItemCount
	select T5."AppObjAbs", T5."ItemCode", T5."BackFlushItemCount"
	From
	(
		--transtype = 59
		select		T0."AppObjAbs", T0."ItemCode", Count(1) as "BackFlushItemCount"
		From		OINM T0 
		inner join	OIGN T1 on	
					T0."ApplObj" IS NOT NULL and T0."ApplObj"=202 and T0."TransType" = 59 and T0."AppObjType"<>'P' 
					and T0."CostMethod" = 'F' and T0."CreatedBy" = T1."DocEntry" 
					and ( T1."VersionNum" IS NULL OR T1."VersionNum" < :compVersion ) 
		left join	IGN1 T2 on T0."CreatedBy" = T2."DocEntry" 
					and T0."DocLineNum" = T2."LineNum" and T0."ItemCode" = T2."ItemCode"
		where		T2."DocEntry" is null
		group by	T0."CreatedBy", T0."AppObjAbs", T0."DocLineNum", T0."ItemCode"

		UNION ALL 
		--transtype = 60
		select		T0."AppObjAbs", T0."ItemCode", Count(1) as "BackFlushItemCount"
		From		OINM T0 
		inner join  OIGE T1 on	
					T0."ApplObj" IS NOT NULL and T0."ApplObj"=202 and T0."TransType" = 60 and T0."AppObjType"<>'P' 
					and T0."CostMethod" = 'F' and T0."CreatedBy" = T1."DocEntry" 
					and ( T1."VersionNum" IS NULL OR T1."VersionNum" < :compVersion ) 
		left join	IGE1 T2 on T0."CreatedBy" = T2."DocEntry" 
					and T0."DocLineNum" = T2."LineNum" and T0."ItemCode" = T2."ItemCode"
		where		T2."DocEntry" is null
		group by	T0."CreatedBy", T0."AppObjAbs", T0."DocLineNum", T0."ItemCode"
	) T5;

create global temporary table tmpIgnoreDupFIFOBackFlushItemCode
									(AppObjAbs int,ItemCode nvarchar(50));
insert into tmpIgnoreDupFIFOBackFlushItemCode
	select 	T0.AppObjAbs, T0.ItemCode
	From 	OINMBackFlushItemCount T0 
	inner join WOR1BackFlushItemCount T1
			on T0.AppObjAbs = T1.DocEntry and T0.ItemCode = T1.ItemCode
	where 	T0.BackFlushItemCount <> T1.BackFlushItemCount 
			and T1.BackFlushItemCount > 1; 
-- to exclude the case that only one line of FIFO item exists in WOR1, but mulitple layers for this item exists in OINM

drop table WOR1BackFlushItemCount;
drop table OINMBackFlushItemCount;
*/
END;
