-- B1 DEPENDS: AFTER:SP:_TmSp_BootCreateGlobalTempTables AFTER:PT:CREATE_TABLES_TO_VIEWS

CREATE PROCEDURE _TmSp_CreateOINMGrouped
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER

AS	
	cc int;
BEGIN

	delete from CreateOINMGrouped_tempCorrInvData;
	
	INSERT INTO CreateOINMGrouped_tempCorrInvData SELECT "TransType", "CreatedBy",
		 "DocLineNum",SUM("InQty" +"OutQty"),MAX("TransSeq") 
		 FROM "OINM"
		 WHERE "TransType" = 163 OR "TransType" = 164
		 GROUP BY "TransType", "CreatedBy", "DocLineNum";	
		
	SELECT MIN("TransNum") As TransNum,
						"TransType" As TransType,"CreatedBy" As CreatedBy,
						MIN("BASE_REF") As BASE_REF,"DocLineNum" As DocLineNum,
						MIN("DocDate") As DocDate,MIN("DocDueDate") As DocDueDate,
						MIN("CardCode") As CardCode,MIN("CardName") As CardName,
						MIN("Ref1") As Ref1,MIN("Ref2") As Ref2,
						MIN("Comments") As Comments,MIN("JrnlMemo") As JrnlMemo,
						MIN("DocTime") As DocTime,"ItemCode" As ItemCode,
						MIN("Dscription") As Dscription,SUM("InQty") As InQty,
						SUM("OutQty") As OutQty,MIN("Price") As Price,
						MIN("Currency") As Currency,MIN("Rate") As Rate,
						MIN("VendorNum") As VendorNum,MIN("SerialNum") As SerialNum,
						"Warehouse" As Warehouse,MIN("TreeType") As TreeType,
						MIN("SlpCode") As SlpCode,MIN("TaxDate") As TaxDate,
						MIN("DataSource") As "DataSource",MIN("PrjCode") As PrjCode,
						MIN("UserSign") As UserSign,MIN("BlockNum") As BlockNum,
						MIN("ImportLog") As ImportLog,MIN("UseDocPric") As UseDocPric,
						MIN("Location") As Location,MIN("CalcPrice") As CalcPrice,
						MIN("OpenQty") As OpenQty,MIN("Instance") As Instance,
						MIN("LastInst") As LastInst,MIN("RevalTotal") As RevalTotal,
						MIN("BaseCurr") As BaseCurr,MIN("ApplObj") As ApplObj,
						MIN("AppObjAbs") As AppObjAbs,MIN("AppObjType") As AppObjType,
						MIN("StockAct") As StockAct,MIN("TrnsfrAct") As TrnsfrAct,
						MIN("PriceDifAc") As PriceDifAc,MIN("VarianceAc") As VarianceAc,
						MIN("ReturnAct") As ReturnAct,MIN("ExcRateAct") As ExcRateAct,
						MIN("ClearAct") As ClearAct,MIN("CostAct") As CostAct,
						MIN("WipAct") As WipAct,MIN("Balance") As Balance,
						MIN("CreateDate") As CreateDate,MIN("BaseLine") As BaseLine,
						SUM("TransValue") As TransValue,SUM("PriceDiff") As PriceDiff,
						MIN("TransSeq") As TransSeq,MIN("InvntAct") As InvntAct,
						MIN("RemMethod") As RemMethod,SUM("OpenValue") As OpenValue,
						MIN("SubLineNum") As SubLineNum,MIN("AppObjLine") As AppObjLine,
						MIN("Expenses") As Expenses,SUM("OpenExp") As OpenExp,
						SUM("Allocation") As Allocation,MIN("OpenAlloc") As OpenAlloc,
						MIN("ExpAlloc") As ExpAlloc,MIN("OExpAlloc") As OExpAlloc,
						MIN("OpenPDiff") As OpenPDiff,MIN("ExchDiff") As ExchDiff,
						SUM("OpenEDiff") As OpenEDiff,SUM("NegInvAdjs") As NegInvAdjs,
						SUM("OpenNegInv") As OpenNegInv,MIN("NegStckAct") As NegStckAct,
						SUM("BTransVal") As BTransVal,	SUM("VarVal") As VarVal,
						SUM("BExpVal") As BExpVal,SUM("CogsVal") As CogsVal,
						SUM("BNegAVal") As BNegAVal,MIN("IOffIncAcc") As IOffIncAcc,
						SUM("IOffIncVal") As IOffIncVal,MIN("DOffDecAcc") As DOffDecAcc,
						SUM("DOffDecVal") As DOffDecVal,MIN("DecAcc") As DecAcc,
						SUM("DecVal") As DecVal,SUM("WipVal") As WipVal,
						MIN("WipVarAcc") As WipVarAcc,SUM("WipVarVal") As WipVarVal,
						MIN("IncAct") As IncAct,MIN("IncVal") As IncVal,
						MIN("ExpCAcc") As ExpCAcc,MIN("CostMethod") As CostMethod,
						MIN("OcrCode") As OcrCode,MIN("BaseQty") As BaseQty,
						MIN("PrevTrans") As PrevTrans,MAX("TransSeq") As hTransSeq,
						MIN("OcrCode2") As OcrCode2,MIN("OcrCode3") As OcrCode3,
						MIN("OcrCode4") As OcrCode4,MIN("OcrCode5") As OcrCode5
	FROM "OINM"
	LEFT OUTER JOIN CreateOINMGrouped_tempCorrInvData ON "OINM"."TransType" = CreateOINMGrouped_tempCorrInvData._CID_TransType 
	AND "OINM"."CreatedBy" = CreateOINMGrouped_tempCorrInvData._CID_CreatedBy 
	AND "OINM"."DocLineNum" = CreateOINMGrouped_tempCorrInvData._CID_DocLineNum
	WHERE "CreatedBy" IS NOT NULL AND
	(("TransType" <> 163 AND "TransType" <> 164) OR
		(("TransType" = 163 or "TransType" = 164) AND (("InQty" + "OutQty") <> 0 OR 
		(("InQty" + "OutQty") = 0 AND CreateOINMGrouped_tempCorrInvData._CID_TotalQty = 0 
		AND "OINM"."TransSeq" = CreateOINMGrouped_tempCorrInvData._CID_MaxTransSeq	))))
	GROUP BY "TransType", "CreatedBy", "DocLineNum", "ItemCode", "Warehouse", "SubLineNum", "AppObjLine"
	UNION ALL
	SELECT "TransNum","TransType","CreatedBy",
						"BASE_REF","DocLineNum","DocDate","DocDueDate",
						"CardCode","CardName","Ref1","Ref2","Comments",
						"JrnlMemo","DocTime","ItemCode","Dscription","InQty",
						"OutQty","Price","Currency","Rate","VendorNum",
						"SerialNum","Warehouse","TreeType","SlpCode",
						"TaxDate","DataSource","PrjCode","UserSign","BlockNum",
						"ImportLog","UseDocPric","Location","CalcPrice","OpenQty",
						"Instance","LastInst","RevalTotal","BaseCurr","ApplObj",
						"AppObjAbs","AppObjType","StockAct","TrnsfrAct","PriceDifAc",
						"VarianceAc","ReturnAct","ExcRateAct","ClearAct",
						"CostAct","WipAct","Balance","CreateDate","BaseLine","TransValue",
						"PriceDiff","TransSeq","InvntAct","RemMethod","OpenValue","SubLineNum",
						"AppObjLine","Expenses","OpenExp","Allocation","OpenAlloc","ExpAlloc",
						"OExpAlloc",	"OpenPDiff","ExchDiff","OpenEDiff","NegInvAdjs","OpenNegInv",
						"NegStckAct","BTransVal","VarVal","BExpVal","CogsVal",
						"BNegAVal","IOffIncAcc","IOffIncVal","DOffDecAcc",
						"DOffDecVal","DecAcc","DecVal","WipVal","WipVarAcc","WipVarVal",
						"IncAct","IncVal","ExpCAcc","CostMethod","OcrCode","BaseQty","PrevTrans",
						"TransSeq" As hTransSeq,"OcrCode2","OcrCode3","OcrCode4",
						"OcrCode5" FROM "OINM"
						WHERE "CreatedBy" IS NULL
	UNION ALL					
	SELECT MIN("TransNum") As TransNum,"TransType" As TransType,
						"CreatedBy" As CreatedBy,	MIN("BASE_REF") As BASE_REF,
						"DocLineNum" As DocLineNum,MIN("DocDate") As DocDate,
						MIN("DocDueDate") As DocDueDate,MIN("CardCode") As CardCode,
						MIN("CardName") As CardName,MIN("Ref1") As Ref1,
						MIN("Ref2") As Ref2,MIN("Comments") As Comments,
						MIN("JrnlMemo") As JrnlMemo,MIN("DocTime") As DocTime,
						"ItemCode" As ItemCode,MIN("Dscription") As Dscription,
						SUM("InQty") As InQty,SUM("OutQty") As OutQty,
						MAX("Price") As Price,MAX("Currency") As Currency,
						MAX("Rate") As Rate,	MAX("VendorNum") As VendorNum,
						MAX("SerialNum") As SerialNum,"Warehouse" As Warehouse,
						MAX("TreeType") As TreeType,MAX("SlpCode") As SlpCode,
						MAX("TaxDate") As TaxDate,MAX("DataSource") As "DataSource",
						MAX("PrjCode") As PrjCode,MAX("UserSign") As UserSign,
						MAX("BlockNum") As BlockNum,MAX("ImportLog") As ImportLog,
						MAX("UseDocPric") As UseDocPric,MAX("Location") As Location,
						MAX("CalcPrice") As CalcPrice,	MAX("OpenQty") As OpenQty,
						MAX("Instance") As Instance,MAX("LastInst") As LastInst,
						MAX("RevalTotal") As RevalTotal,	MAX("BaseCurr") As BaseCurr,
						MAX("ApplObj") As ApplObj,	MAX("AppObjAbs") As AppObjAbs,
						MAX("AppObjType") As AppObjType,	MAX("StockAct") As StockAct,
						MAX("TrnsfrAct") As TrnsfrAct,MAX("PriceDifAc") As PriceDifAc,
						MAX("VarianceAc") As VarianceAc,MAX("ReturnAct") As ReturnAct,
						MAX("ExcRateAct") As ExcRateAct,MAX("ClearAct") As ClearAct,
						MAX("CostAct") As CostAct,MAX("WipAct") As WipAct,
						MAX("Balance") As Balance,MAX("CreateDate") As CreateDate,
						MAX("BaseLine") As BaseLine,SUM("TransValue") As TransValue,
						SUM("PriceDiff") As PriceDiff,MIN("TransSeq") As TransSeq,
						MAX("InvntAct") As InvntAct,MAX("RemMethod") As RemMethod,
						SUM("OpenValue") As OpenValue,"SubLineNum" As SubLineNum,
						MAX("AppObjLine") As AppObjLine,MAX("Expenses") As Expenses,
						SUM("OpenExp") As OpenExp,SUM("Allocation") As Allocation,
						MAX("OpenAlloc") As OpenAlloc,MAX("ExpAlloc") As ExpAlloc,
						MAX("OExpAlloc") As OExpAlloc,MAX("OpenPDiff") As OpenPDiff,
						MAX("ExchDiff") As ExchDiff,SUM("OpenEDiff") As OpenEDiff,
						SUM("NegInvAdjs") As NegInvAdjs,SUM("OpenNegInv") As OpenNegInv,
						MAX("NegStckAct") As NegStckAct,SUM("BTransVal") As BTransVal,
						SUM("VarVal") As VarVal,SUM("BExpVal") As BExpVal,
						SUM("CogsVal") As CogsVal,SUM("BNegAVal") As BNegAVal,
						MAX("IOffIncAcc") As IOffIncAcc,SUM("IOffIncVal") As IOffIncVal,
						MAX("DOffDecAcc") As DOffDecAcc,	SUM("DOffDecVal") As DOffDecVal,
						MAX("DecAcc") As DecAcc,	SUM("DecVal") As DecVal,
						SUM("WipVal") As WipVal,	MAX("WipVarAcc") As WipVarAcc,
						SUM("WipVarVal") As WipVarVal,MAX("IncAct") As IncAct,
						MAX("IncVal") As IncVal,MAX("ExpCAcc") As ExpCAcc,
						MAX("CostMethod") As CostMethod,	MAX("OcrCode") As OcrCode,
						MAX("BaseQty") As BaseQty,MAX("PrevTrans") As PrevTrans,
						MAX("TransSeq") As hTransSeq,	MAX("OcrCode2") As OcrCode2,
						MAX("OcrCode3") As OcrCode3,	MAX("OcrCode4") As OcrCode4,
						MAX("OcrCode5") As OcrCode5	FROM "OINM"
						LEFT OUTER JOIN CreateOINMGrouped_tempCorrInvData ON "OINM"."TransType" = CreateOINMGrouped_tempCorrInvData._CID_TransType 
						AND "OINM"."CreatedBy" = CreateOINMGrouped_tempCorrInvData._CID_CreatedBy 
						AND "OINM"."DocLineNum" = CreateOINMGrouped_tempCorrInvData._CID_DocLineNum
						WHERE							
							(("TransType" = 163 or "TransType" = 164) AND ("InQty" + "OutQty") = 0 AND 
							(CreateOINMGrouped_tempCorrInvData._CID_TotalQty <> 0 OR 
							"OINM"."TransSeq" <> CreateOINMGrouped_tempCorrInvData._CID_MaxTransSeq))
						GROUP BY "TransType", "CreatedBy", "DocLineNum", "ItemCode", 
						"Warehouse", "SubLineNum", "AppObjLine";
	
	-- feature not supported CREATE INDEX ix_MaxTransseq_from_hTransseq ON #tmpOINMGrouped("hTransseq" ASC);

	delete from CreateOINMGrouped_tempCorrInvData;
END;
