-- B1 DEPENDS: AFTER:PT:CREATE_TABLES_TO_VIEWS

CREATE PROCEDURE _TmSp_UpdateAppObjLineOINM_DupBackFlushItems
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER
AS

BEGIN
/***** standard BOM with duplicated components released by backflush, wrong OINM.AppObjLine generated by IGN **************/

-- Step 1: build backflush item rank in WOR1
CREATE LOCAL TEMPORARY TABLE #tmpWOR1 (
DocEntry INTEGER,
ItemCode INTEGER,
LineNum NVARCHAR (20)
);

/*
insert into #tmpWOR1
select	"DocEntry", "ItemCode", "LineNum" 
from 	WOR1
where 	"IssueType" = 'B' and 
		( 
			"DocEntry" in ( select AppObjAbs from #tmpIgnoreDupItemCodeIGN1) or
			"DocEntry" in ( select AppObjAbs from #tmpIgnoreDupItemCodeIGE1)
		)		
		and "DocEntry" not in (select AppObjAbs from #tmpIgnoreDupFIFOBackFlushItemCode);
		
CREATE LOCAL TEMPORARY TABLE #tmpWOR1withIndex (
DocEntry INTEGER,
ItemCode INTEGER,
LineNum INTEGER,
backFlushIndex INTEGER
);

INSERT INTO #tmpWOR1withIndex
select	DocEntry,ItemCode,LineNum,(select count(*) from #tmpWOR1 w1 
	where w1.LineNum <w2.LineNum 
		and w1.DocEntry=w2.DocEntry 
		and w1.ItemCode = w2.ItemCode) +1 as backFlushIndex 
from	#tmpWOR1 w2
order by DocEntry,ItemCode,LineNum,backFlushIndex ;


CREATE LOCAL TEMPORARY TABLE #tmpOINM (
TransSeq INTEGER,
ItemCode INTEGER,
CreatedBy INTEGER,
AppObjAbs INTEGER,
DocLineNum INTEGER
);

-- Step 2: build rank in OINM for backflush items
insert into #tmpOINM
select	T3."TransSeq", T3."ItemCode", T3."CreatedBy", T3."AppObjAbs", T3."DocLineNum"
From
(
--      Only transtype 59 OINM records released by backflush will be included
select	T0."TransSeq", T0."ItemCode", T0."CreatedBy", T0."AppObjAbs", T0."DocLineNum"
From 	OINM T0 Left Join IGN1 T1 
ON 		T0."CreatedBy" =T1."DocEntry" and T0."DocLineNum" = T1."LineNum" and T0."ItemCode" = T1."ItemCode"
where	T1."DocEntry" is null AND
		T0."ApplObj" IS NOT NULL AND T0."ApplObj"=202 and T0."TransType"=59 and T0."AppObjType"<>'P' 
		AND T0."AppObjAbs" in 
		( 
			select AppObjAbs from #tmpIgnoreDupItemCodeIGN1
		)				
		AND T0."AppObjAbs" not in
		(
			select AppObjAbs from #tmpIgnoreDupFIFOBackFlushItemCode
		) 
UNION ALL
--      Only transtype 60 OINM records released by backflush will be included
select	T0."TransSeq", T0."ItemCode", T0."CreatedBy", T0."AppObjAbs", T0."DocLineNum"
From 	OINM T0 Left Join IGE1 T1 
ON 		T0."CreatedBy" =T1."DocEntry" and T0."DocLineNum" = T1."LineNum" and T0."ItemCode" = T1."ItemCode"
where	T1."DocEntry" is null AND
		T0."ApplObj" IS NOT NULL AND T0."ApplObj"=202 and T0."TransType"=60 and T0."AppObjType"<>'P' 
		AND T0."AppObjAbs" in 
		( 
			select AppObjAbs from #tmpIgnoreDupItemCodeIGE1
		)				
		AND T0."AppObjAbs" not in
		(
			select AppObjAbs from #tmpIgnoreDupFIFOBackFlushItemCode
		) 
)T3 ;

CREATE LOCAL TEMPORARY TABLE #tmpOINMwithIndex (
TransSeq INTEGER,
ItemCode INTEGER,
AppObjAbs INTEGER,
DocLineNum INTEGER,
backFlushIndex INTEGER
);


INSERT INTO #tmpWOR1withIndex
select	DocEntry,ItemCode,LineNum,(select count(*) from #tmpWOR1 w1 where w1.LineNum <w2.LineNum and w1.DocEntry=w2.DocEntry and w1.ItemCode = w2.ItemCode) + 1
from	#tmpWOR1 w2
order by DocEntry,ItemCode,LineNum;


-- include CreatedBy, DocLineNum in PARTITION BY, because IGN for WOR can be done multiple times.
insert into #tmpOINMwithIndex
select	TransSeq, ItemCode, AppObjAbs, DocLineNum,(select count(*) from #tmpOINM w1 
	where w1.TransSeq <w2.TransSeq 
		and w1.AppObjAbs=w2.AppObjAbs 
		and w1.CreatedBy=w2.CreatedBy 
		and  w1.DocLineNum=w2.DocLineNum and w1.ItemCode=w2.ItemCode) + 1 as backFlushIndex
from	#tmpOINM w2
order by TransSeq, ItemCode, AppObjAbs, DocLineNum ,backFlushIndex;

drop table #tmpWOR1;
drop table #tmpOINM;
drop table #tmpIgnoreDupFIFOBackFlushItemCode;
drop table #tmpIgnoreDupItemCodeIGN1;
drop table #tmpIgnoreDupItemCodeIGE1;

-- Step 3: update OINM.AppObjLine
exec ' 
Update	OINM 
Set		"AppObjLine" = T2.LineNum
From	OINM T0, #tmpOINMwithIndex T1, #tmpWOR1withIndex T2 
where	OINM."TransSeq" = T1.TransSeq  and 
		T1.AppObjAbs = T2.DocEntry and T1.ItemCode = T2.ItemCode and T1.backFlushIndex = T2.backFlushIndex and
		OINM."DocLineNum" = T1.DocLineNum';

--		handle only one line of FIFO itemcode exists in WOR1, but mulitple layers for this item exist in OINM
exec '
Update	OINM
Set		"AppObjLine" = T2.LineNum
From	OINM T0, #tmpOINMwithIndex T1, #tmpWOR1withIndex T2 
where	OINM."TransSeq" = T1.TransSeq and T1.AppObjAbs = T2.DocEntry 
		and T1.ItemCode = T2.ItemCode and OINM."CostMethod" =  ''F''  
		and OINM."DocLineNum" = T1.DocLineNum 
		and OINM."TransSeq" not in 
		(
			select T0."TransSeq" 
			From	OINM T0, #tmpOINMwithIndex T1, #tmpWOR1withIndex T2  
			where	T0."TransSeq" = T1.TransSeq  and 
					T1.AppObjAbs = T2.DocEntry and T1.ItemCode = T2.ItemCode and T1.backFlushIndex = T2.backFlushIndex and 
					T0."DocLineNum" = T1.DocLineNum 			
		)';
		
drop table #tmpOINMwithIndex;
drop table #tmpWOR1withIndex;
*/
drop table #tmpWOR1;

END;
