-- B1 DEPENDS: AFTER:SP:_TmSp_BootCreateGlobalTempTables AFTER:PT:CREATE_TABLES_TO_VIEWS

CREATE PROCEDURE _TmSp_UpdateSubLineNumOINM 
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER

AS
v_Count int;
v_TransSeq varchar(100);
v_ItemCode varchar(100);
v_Warehouse varchar(100);
v_TransType varchar(100);
v_CreatedBy varchar(100);
v_DocLineNum varchar(100);
v_LastTransSeq varchar(100);
v_LastItemCode varchar(100);
v_LastWarehouse varchar(100);
v_LastTransType varchar(100);
v_LastCreatedBy varchar(100);
v_LastDocLineNum varchar(100);
v_SQL varchar(1000);
v_CostMethod varchar(100);
CURSOR INM_Cursor FOR 
select P1."TransSeq", P1."ItemCode", P1."Warehouse", P1."TransType", P1."CreatedBy", P1."DocLineNum", P1."CostMethod" 
From OINM P1 
where P1."TreeType"='A' and P1."TransType"<>162 order by "TransSeq";

BEGIN

	delete from UpdateSubLineNumOINM_tmp_OINMAllASMBomEx;
	delete from UpdateSubLineNumOINM_tmp_OINMAllASMBom;
	delete from UpdateSubLineNumOINM_tmp_OINMAllASMBom_Index;

	v_LastTransSeq := '';
	v_LastItemCode := '';
	v_LastWarehouse := '';
	v_LastTransType := '';
	v_LastCreatedBy := '';
	v_LastDocLineNum := '';
	v_Count := 0;
	
/*		
	insert into #tmp_OINMAllASMBomEx
	select P1."TransSeq", P1."ItemCode", P1."Warehouse", P1."TransType", P1."CreatedBy", P1."DocLineNum", P1."CostMethod", -1 As GroupNum
	from OINM P1 
	where P1."TreeType"='A' and P1."TransType"<>162;
*/
	OPEN INM_Cursor;

	FETCH INM_Cursor into v_TransSeq, v_ItemCode, v_Warehouse, v_TransType, v_CreatedBy, v_DocLineNum, v_CostMethod;
	WHILE NOT INM_Cursor::NOTFOUND DO
		IF (:v_ItemCode <> :v_LastItemCode) OR (:v_Warehouse <> :v_LastWarehouse) OR (:v_TransType <> :v_LastTransType) OR (:v_CreatedBy <> :v_LastCreatedBy) OR 
			(:v_DocLineNum <> :v_LastDocLineNum)
		THEN
			v_Count := :v_Count + 1;
		END IF;
		
		INSERT INTO UpdateSubLineNumOINM_tmp_OINMAllASMBomEx values (:v_TransSeq,:v_ItemCode,:v_Warehouse,:v_TransType,:v_CreatedBy,:v_DocLineNum,:v_CostMethod, :v_Count);
		
		--HANA doesn't support update tempdb
		--update #tmp_OINMAllASMBomEx set GroupNum = :v_Count where TransSeq = :v_TransSeq;
		
		v_LastTransSeq := :v_TransSeq;
		v_LastItemCode := :v_ItemCode;
		v_LastWarehouse := :v_Warehouse;
		v_LastTransType := :v_TransType;
		v_LastCreatedBy := :v_CreatedBy;
		v_LastDocLineNum := :v_DocLineNum;
		FETCH INM_Cursor into v_TransSeq, v_ItemCode, v_Warehouse, v_TransType, v_CreatedBy, v_DocLineNum, v_CostMethod;
	END WHILE;
	CLOSE INM_Cursor;
			
	-- [NOT FIFO ASM BOM]
	-- Handle all transactions with Assembly BOM items (parents and sons)
	-- 1)  Create temp tables of all parents and sons
	insert into UpdateSubLineNumOINM_tmp_OINMAllASMBom
	select P1."TransSeq" As MinTransSeq, P1."TransSeq" As MaxTransSeq, P1."ItemCode",P1."Warehouse",P1."TransType",P1."CreatedBy",P1."DocLineNum", -1 As NewSubLineNum
	from OINM P1 
	where P1."TreeType"='A' and P1."CostMethod"<>'F' and P1."TransType"<>162
	UNION ALL
	-- [FIFO ASM BOM]
	-- 2) Handle all FIFO transactions with Assembly BOM items grouped (parents and sons)
	-- The group is for one row in OIVL and several rows in IVL1
	-- Create temp tables of all grouped parents and sons
	select MIN(TransSeq) As MinTransSeq, MAX(TransSeq) As MaxTransSeq,
		P1.ItemCode,P1.Warehouse,P1.TransType,P1.CreatedBy,P1.DocLineNum, -1 As NewSubLineNum
	from UpdateSubLineNumOINM_tmp_OINMAllASMBomEx P1 
	where P1.CostMethod='F'
	group by P1.TransType,P1.CreatedBy,P1.DocLineNum,P1.ItemCode,P1.Warehouse, P1.GroupNum;
		
	-- 3) Update all asm BOM transactions with rank
	insert into UpdateSubLineNumOINM_tmp_OINMAllASMBom_Index
	SELECT MinTransSeq, MaxTransSeq, (SELECT COUNT(*) FROM UpdateSubLineNumOINM_tmp_OINMAllASMBom t1 
		where t1.TransType = t2.TransType and t1.CreatedBy = t2.CreatedBy and t1.DocLineNum=t2.DocLineNum 
		and (t1.ItemCode || cast(t1.MinTransSeq as nvarchar(5000)) 
			< (t2.ItemCode || cast(t2.MinTransSeq as nvarchar(5000))))) as Rnk
	FROM UpdateSubLineNumOINM_tmp_OINMAllASMBom t2
	ORDER BY MinTransSeq,MaxTransSeq,Rnk;

	-- 4) Update asm BOM transactions SubLineNum with the rank.
exec '
	UPDATE OINM P1
	SET P1."SubLineNum" = P2.Rnk
	FROM OINM P1
	INNER JOIN UpdateSubLineNumOINM_tmp_OINMAllASMBom_Index P2
	ON P1."TransSeq" = P2.MinTransSeq AND
	P1."TreeType"=''A'' and P1."CostMethod"<>''F'' and P1."TransType"<>162';
exec '
	UPDATE OINM P1
	SET P1."SubLineNum" = P2.rnk
	FROM OINM P1
	INNER JOIN UpdateSubLineNumOINM_tmp_OINMAllASMBom_Index P2
	ON P1."TransSeq" >= P2.MinTransSeq AND
	P1."TransSeq" <= P2.MaxTransSeq AND
	P1."CostMethod"=''F'' and P1."TreeType"=''A'' and P1."TransType"<>162';

	delete from UpdateSubLineNumOINM_tmp_OINMAllASMBomEx;
	delete from UpdateSubLineNumOINM_tmp_OINMAllASMBom;
	delete from UpdateSubLineNumOINM_tmp_OINMAllASMBom_Index;

END;
