-- B1 DEPENDS: BEFORE:PT:PROCESS_START AFTER:SP:_TmSp_BootCreateGlobalTempTables2

CREATE PROCEDURE _TmSp_UpgradeFillOILMRevalBasedDocsQuantity 
LANGUAGE SQLSCRIPT 
SQL SECURITY INVOKER

AS 
qtyDec int;

  BEGIN 
    --get the current quantity decimal    
     
    SELECT "QtyDec" INTO qtyDec FROM OADM;
    /*-- We use temp table here to improve the update performance. 
	-- Select calculated newQty to the tmp table 
	if the PCH1.quantity equals to PDN1.quantity, meaning it's a fully copy, so it's preciser to update OILM.quantity (PCH) by OILM.quantity (GRPO). */
    DELETE FROM "TMP_UpgradeFillOILM_NewQty";
	
	exec '
	INSERT INTO "TMP_UpgradeFillOILM_NewQty"
	SELECT t0."MessageID",
            (CASE 
              WHEN t3."Quantity" = t2."Quantity"
              THEN t1."Quantity" 
              ELSE ROUND(t3."Quantity" * ROUND((t1."Quantity" / nullif(t2."Quantity",0)),' || :qtyDec || '),' || :qtyDec || ') 
            END) 
    FROM OILM t0, 
         OILM t1, 
         B1_NON_BASE_DOCS_VIEW t2, 
         B1_BASED_DOCS_VIEW t3 
    WHERE  t0."TransType" = 18 
           AND t1."TransType" = 20 
           AND t0."BaseType" = t1."TransType" 
           AND t0."BaseAbsEnt" = t1."DocEntry" 
           AND t0."BaseLine" = t1."DocLineNum" 
           AND t0."ItemCode" = t1."ItemCode" 
           AND t0."LocCode" = t1."LocCode" 
           AND t0."TransType" = t3."ObjType" 
           AND t0."DocEntry" = t3."DocEntry" 
           AND t0."DocLineNum" = t3."LineNum" 
           AND t1."TransType" = t2."ObjType" 
           AND t1."DocEntry" = t2."DocEntry" 
           AND t1."DocLineNum" = t2."LineNum" 
           AND t2."Quantity" <> 0 
           AND t2."Quantity" IS NOT NULL
    UNION ALL 
    SELECT t0."MessageID", 
           (CASE 
              WHEN t3."Quantity" = t2."Quantity" 
              THEN t1."Quantity" 
              ELSE Round(t3."Quantity" * Round((t1."Quantity" / nullif(t2."Quantity",0)),' || :qtyDec || '),' || :qtyDec || ') 
            END) AS newqty 
	FROM OILM t0,
		OILM t1, 
        "B1_NON_BASE_DOCS_VIEW" t2, 
        "B1_BASED_DOCS_VIEW" t3 
    WHERE  t0."TransType" = 13 
	   AND t1."TransType" = 15 
	   AND t0."BaseType" = t1."TransType" 
	   AND t0."BaseAbsEnt" = t1."DocEntry" 
	   AND t0."BaseLine" = t1."DocLineNum" 
	   AND t0."ItemCode" = t1."ItemCode" 
	   AND t0."LocCode" = t1."LocCode" 
	   AND t0."TransType" = t3."ObjType" 
	   AND t0."DocEntry" = t3."DocEntry" 
	   AND t0."DocLineNum" = t3."LineNum" 
	   AND t1."TransType" = t2."ObjType" 
	   AND t1."DocEntry" = t2."DocEntry" 
	   AND t1."DocLineNum" = t2."LineNum" 
	   AND t2."Quantity" <> 0 
	   AND t2."Quantity" IS NOT NULL';
	   
    -- Remark: Do not compare doc ItemcCode with OILM ItemCode because it is different in assembly BOM. 
    --T0.ItemCode = T3.ItemCode AND 
    --T1.ItemCode = T2.ItemCode
   
    -- Update the OILM.Quantity field with the newQty 
    UPDATE OILM T0
    SET    "Quantity" = (SELECT newqty FROM "TMP_UpgradeFillOILM_NewQty" t1 WHERE T0."MessageID" = t1.MessageID);

    DELETE FROM "TMP_UpgradeFillOILM_NewQty";
  END;
