CREATE PROCEDURE DA_KMEANS_PREPARE(IN SCHEMANAME VARCHAR(100), IN SUFFIX VARCHAR(50), IN DATA_SIGN_TABLE VARCHAR(100)) LANGUAGE SQLSCRIPT  SQL SECURITY INVOKER  AS BEGIN     DECLARE ROWCOUNT INTEGER;     DECLARE ROWINDEX INTEGER;     DECLARE COLUMNNAME VARCHAR(100);     DECLARE COLUMNTYPE VARCHAR(100);     DECLARE ISKEY INTEGER;     DECLARE PROCEDURENAME VARCHAR(150);     DECLARE ASSIGN_TABLE TABLE ("POSITION" INT, "SCHEMA_NAME" NVARCHAR(256), "TYPE_NAME" NVARCHAR(256), "PARAMETER_TYPE" VARCHAR(7));     DECLARE CREATE_DATA_TABLE_TYPE CLOB;     DECLARE CREATE_CENTER_TABLE_TYPE CLOB;     DECLARE CREATE_ASSIGNED_TABLE_TYPE VARCHAR(200);     CALL DA_DROP_TYPE(:SCHEMANAME, 'DA_KMEANS_DATA_T_' || :SUFFIX);     CALL DA_DROP_TYPE(:SCHEMANAME, 'DA_KMEANS_CONTROL_T_' || :SUFFIX);     CALL DA_DROP_TYPE(:SCHEMANAME, 'DA_KMEANS_ASSIGNED_T_' || :SUFFIX);     CALL DA_DROP_TYPE(:SCHEMANAME, 'DA_KMEANS_CENTERS_T_' || :SUFFIX);         CALL DA_DROP_TYPE(:SCHEMANAME, 'DA_KMEANS_SIL_CENTERS_T_' || :SUFFIX);     CALL DA_DROP_TYPE(:SCHEMANAME, 'DA_KMEANS_STATISTIC_T_' || :SUFFIX);     SELECT COUNT(*) INTO ROWCOUNT FROM "PUBLIC"."M_TEMPORARY_TABLES" WHERE TABLE_NAME='#TEMP_DA_KMEANS_SIGN_TABLE' AND CONNECTION_ID=CURRENT_CONNECTION;     IF ROWCOUNT>0 THEN         DROP TABLE #TEMP_DA_KMEANS_SIGN_TABLE;     END IF;      CREATE LOCAL TEMPORARY COLUMN TABLE #TEMP_DA_KMEANS_SIGN_TABLE(COLUMNNAME VARCHAR(100), COLUMNTYPE VARCHAR(100), ISKEY INTEGER);     EXECUTE IMMEDIATE 'INSERT INTO #TEMP_DA_KMEANS_SIGN_TABLE SELECT * FROM '||:DATA_SIGN_TABLE;     CREATE_DATA_TABLE_TYPE = '';     CREATE_CENTER_TABLE_TYPE = '';     SELECT COUNT(*) INTO ROWCOUNT FROM #TEMP_DA_KMEANS_SIGN_TABLE;     FOR ROWINDEX IN 0 .. :ROWCOUNT-1 DO         SELECT "COLUMNNAME", "COLUMNTYPE", "ISKEY" INTO COLUMNNAME, COLUMNTYPE, ISKEY FROM #TEMP_DA_KMEANS_SIGN_TABLE LIMIT 1 OFFSET :ROWINDEX;         IF ROWINDEX < :ROWCOUNT-1 THEN             CREATE_DATA_TABLE_TYPE = :CREATE_DATA_TABLE_TYPE || '"' || :COLUMNNAME ||  '" ' || :COLUMNTYPE || ', ';         ELSE             CREATE_DATA_TABLE_TYPE = :CREATE_DATA_TABLE_TYPE || '"' || :COLUMNNAME ||  '" ' || :COLUMNTYPE;         END IF;         IF ISKEY = 0 THEN             CREATE_CENTER_TABLE_TYPE = :CREATE_CENTER_TABLE_TYPE || ', "' || :COLUMNNAME || '" ' || :COLUMNTYPE;         END IF;     END FOR;     CREATE_DATA_TABLE_TYPE = 'CREATE TYPE DA_KMEANS_DATA_T_'|| :SUFFIX ||' AS TABLE('|| :CREATE_DATA_TABLE_TYPE || ')';     CREATE_CENTER_TABLE_TYPE = 'CREATE TYPE DA_KMEANS_CENTERS_T_'|| :SUFFIX ||' AS TABLE("CLUSTER_ID" INTEGER'|| :CREATE_CENTER_TABLE_TYPE || ')';     EXECUTE IMMEDIATE (:CREATE_DATA_TABLE_TYPE);     EXECUTE IMMEDIATE (:CREATE_CENTER_TABLE_TYPE);     SELECT "COLUMNNAME", "COLUMNTYPE", "ISKEY" INTO COLUMNNAME, COLUMNTYPE, ISKEY FROM #TEMP_DA_KMEANS_SIGN_TABLE WHERE ISKEY = 1;     CREATE_ASSIGNED_TABLE_TYPE = 'CREATE TYPE DA_KMEANS_ASSIGNED_T_'|| :SUFFIX ||' AS TABLE("'|| :COLUMNNAME ||'" '|| :COLUMNTYPE ||',"CLUSTER" INTEGER,"DISTANCE" DOUBLE,"SLIGHT_SILHOUETTE" DOUBLE)';     EXECUTE IMMEDIATE (:CREATE_ASSIGNED_TABLE_TYPE);     EXECUTE IMMEDIATE 'CREATE TYPE DA_KMEANS_CONTROL_T_'|| :SUFFIX ||' AS TABLE("NAME" VARCHAR (100),"INTARGS" INTEGER,"DOUBLEARGS" DOUBLE,"STRINGARGS" VARCHAR (100))';     EXECUTE IMMEDIATE 'CREATE TYPE DA_KMEANS_SIL_CENTERS_T_'|| :SUFFIX ||' AS TABLE("CLUSTER_ID" INTEGER,"SLIGHT_SILHOUETTE" DOUBLE)';     EXECUTE IMMEDIATE 'CREATE TYPE DA_KMEANS_STATISTIC_T_'|| :SUFFIX ||' AS TABLE("NAME" VARCHAR(50),"VALUE" DOUBLE)';     SELECT COUNT(*) INTO ROWCOUNT FROM "PUBLIC"."M_TEMPORARY_TABLES" WHERE TABLE_NAME='#DA_KMEANS_PDATA_TBL' AND CONNECTION_ID=CURRENT_CONNECTION;     IF ROWCOUNT>0 THEN         DROP TABLE #DA_KMEANS_PDATA_TBL;     END IF;     CREATE LOCAL TEMPORARY COLUMN TABLE #DA_KMEANS_PDATA_TBL("POSITION" INT, "SCHEMA_NAME" NVARCHAR(256), "TYPE_NAME" NVARCHAR(256), "PARAMETER_TYPE" VARCHAR(7));     INSERT INTO #DA_KMEANS_PDATA_TBL VALUES (1, :SCHEMANAME, 'DA_KMEANS_DATA_T_'|| :SUFFIX, 'IN');     INSERT INTO #DA_KMEANS_PDATA_TBL VALUES (2, :SCHEMANAME, 'DA_KMEANS_CONTROL_T_'|| :SUFFIX, 'IN');     INSERT INTO #DA_KMEANS_PDATA_TBL VALUES (3, :SCHEMANAME, 'DA_KMEANS_ASSIGNED_T_'|| :SUFFIX, 'OUT');     INSERT INTO #DA_KMEANS_PDATA_TBL VALUES (4, :SCHEMANAME, 'DA_KMEANS_CENTERS_T_'|| :SUFFIX, 'OUT');     INSERT INTO #DA_KMEANS_PDATA_TBL VALUES (5, :SCHEMANAME, 'DA_KMEANS_SIL_CENTERS_T_'|| :SUFFIX, 'OUT');     INSERT INTO #DA_KMEANS_PDATA_TBL VALUES (6, :SCHEMANAME, 'DA_KMEANS_STATISTIC_T_'|| :SUFFIX, 'OUT');     PROCEDURENAME = 'DA_KMEANS_PROC_' || :SUFFIX;     ASSIGN_TABLE = SELECT * FROM #DA_KMEANS_PDATA_TBL;     EXECUTE IMMEDIATE 'CALL "SYS".AFLLANG_WRAPPER_PROCEDURE_DROP(''' || :SCHEMANAME || ''', ''' || :PROCEDURENAME || ''')';     EXECUTE IMMEDIATE 'CALL "SYS".AFLLANG_WRAPPER_PROCEDURE_CREATE(''AFLPAL'', ''KMEANS'', ''' || :SCHEMANAME || ''', ''' || :PROCEDURENAME || ''', ''#DA_KMEANS_PDATA_TBL'')';     SELECT :PROCEDURENAME AS PROCNAME FROM DUMMY;     DROP TABLE #DA_KMEANS_PDATA_TBL; END