CREATE PROCEDURE "DP_INIT" (IN schemaName VARCHAR(100), OUT MFSProcCount INT, OUT LRProcCount INT) LANGUAGE SQLSCRIPT  SQL SECURITY INVOKER  AS BEGIN     DECLARE ROWCNT INT;          SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_MULTIPLEFORECASTSMOOTHING_DATA_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE PAL_MULTIPLEFORECASTSMOOTHING_DATA_T';      END IF;     EXECUTE IMMEDIATE 'CREATE TYPE PAL_MULTIPLEFORECASTSMOOTHING_DATA_T AS TABLE ("GROUPID" VARCHAR (100), "TIMESTAMP" INT, "VALUE" DOUBLE)';     SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_FORECASTSLR_DATA_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE PAL_FORECASTSLR_DATA_T';      END IF;     EXECUTE IMMEDIATE 'CREATE TYPE PAL_FORECASTSLR_DATA_T AS TABLE ("TIMESTAMP" INTEGER, "Y" DOUBLE)';          SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_MULTIPLEFORECASTCONTROL_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE PAL_MULTIPLEFORECASTCONTROL_T';     END IF;     EXECUTE IMMEDIATE 'CREATE TYPE PAL_MULTIPLEFORECASTCONTROL_T AS TABLE ("GROUPID" VARCHAR (100), "NAME" VARCHAR(100), "INTARGS" INT, "DOUBLEARGS" DOUBLE, "STRINGARGS" VARCHAR(100))';     SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_FORECASTSLR_CONTROL_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE PAL_FORECASTSLR_CONTROL_T';     END IF;     EXECUTE IMMEDIATE 'CREATE TYPE PAL_FORECASTSLR_CONTROL_T AS TABLE ("NAME" VARCHAR (50), "INTARGS" INTEGER, "DOUBLEARGS" DOUBLE, "STRINGARGS" VARCHAR (100))';          SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='MULTIPLEFORECAST_OUTPARAMETER_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE MULTIPLEFORECAST_OUTPARAMETER_T';     END IF;     EXECUTE IMMEDIATE 'CREATE TYPE MULTIPLEFORECAST_OUTPARAMETER_T AS TABLE ("GROUPID" VARCHAR (100), "NAME" VARCHAR(100), "VALUE" VARCHAR(100))';     SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='FORECASTSLR_OUTPARAMETER_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE FORECASTSLR_OUTPARAMETER_T';     END IF;     EXECUTE IMMEDIATE 'CREATE TYPE FORECASTSLR_OUTPARAMETER_T AS TABLE ("NAME" VARCHAR (50), "VALUE" DOUBLE)';          SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_MULTIPLEFORECAST_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE PAL_MULTIPLEFORECAST_T';     END IF;     EXECUTE IMMEDIATE 'CREATE TYPE PAL_MULTIPLEFORECAST_T AS TABLE ("GROUPID" VARCHAR (100), "TIMESTAMP" INT, "VALUE" DOUBLE, "DIFFERENCE" DOUBLE)';     SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_FORECASTSLR_T' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TYPE PAL_FORECASTSLR_T';     END IF;     EXECUTE IMMEDIATE 'CREATE TYPE PAL_FORECASTSLR_T AS TABLE ("TIMESTAMP" INTEGER, "VALUE" DOUBLE)';          SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_MULTIPLEFORECAST_PDATA_TBL' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TABLE PAL_MULTIPLEFORECAST_PDATA_TBL';     END IF;     CREATE COLUMN TABLE PAL_MULTIPLEFORECAST_PDATA_TBL("POSITION" INT, "SCHEMA_NAME" VARCHAR(100), "TYPE_NAME" VARCHAR(100), "PARAMETER_TYPE" VARCHAR(100));          EXECUTE IMMEDIATE 'INSERT INTO PAL_MULTIPLEFORECAST_PDATA_TBL VALUES(1, '''|| :schemaName ||''', ''PAL_MULTIPLEFORECASTSMOOTHING_DATA_T'', ''IN'')';     EXECUTE IMMEDIATE 'INSERT INTO PAL_MULTIPLEFORECAST_PDATA_TBL VALUES(2, '''|| :schemaName ||''', ''PAL_MULTIPLEFORECASTCONTROL_T'',''IN'')';     EXECUTE IMMEDIATE 'INSERT INTO PAL_MULTIPLEFORECAST_PDATA_TBL VALUES(3, '''|| :schemaName ||''', ''MULTIPLEFORECAST_OUTPARAMETER_T'', ''OUT'')';     EXECUTE IMMEDIATE 'INSERT INTO PAL_MULTIPLEFORECAST_PDATA_TBL VALUES(4, '''|| :schemaName ||''', ''PAL_MULTIPLEFORECAST_T'', ''OUT'')';               SELECT COUNT(*) INTO ROWCNT FROM M_TABLES WHERE TABLE_NAME='PAL_FORECASTSLR_PDATA_TBL' AND SCHEMA_NAME=:schemaName;     IF ROWCNT>0 THEN     EXECUTE IMMEDIATE 'DROP TABLE PAL_FORECASTSLR_PDATA_TBL';     END IF;     CREATE COLUMN TABLE PAL_FORECASTSLR_PDATA_TBL("POSITION" INT, "SCHEMA_NAME" VARCHAR(100), "TYPE_NAME" VARCHAR(100), "PARAMETER_TYPE" VARCHAR(100));          EXECUTE IMMEDIATE 'INSERT INTO PAL_FORECASTSLR_PDATA_TBL VALUES(1, '''|| :schemaName ||''', ''PAL_FORECASTSLR_DATA_T'', ''in'')';     EXECUTE IMMEDIATE 'INSERT INTO PAL_FORECASTSLR_PDATA_TBL VALUES(2, '''|| :schemaName ||''', ''PAL_FORECASTSLR_CONTROL_T'',''in'')';     EXECUTE IMMEDIATE 'INSERT INTO PAL_FORECASTSLR_PDATA_TBL VALUES(3, '''|| :schemaName ||''', ''FORECASTSLR_OUTPARAMETER_T'', ''out'')';     EXECUTE IMMEDIATE 'INSERT INTO PAL_FORECASTSLR_PDATA_TBL VALUES(4, '''|| :schemaName ||''', ''PAL_FORECASTSLR_T'', ''out'')';          CALL SYS.AFLLANG_WRAPPER_PROCEDURE_DROP(:schemaName, 'PALMULTIPLEFORECASTSMOOTHING_PROC');     EXECUTE IMMEDIATE 'CALL SYS.AFLLANG_WRAPPER_PROCEDURE_CREATE(''AFLPAL'', ''MULTIPLEFORECASTSMOOTHING'','''|| :schemaName ||''', ''PALMULTIPLEFORECASTSMOOTHING_PROC'',PAL_MULTIPLEFORECAST_PDATA_TBL)';          CALL SYS.AFLLANG_WRAPPER_PROCEDURE_DROP(:schemaName, 'PALLRWITHSEASONALADJUST_PROC');     EXECUTE IMMEDIATE 'CALL SYS.AFLLANG_WRAPPER_PROCEDURE_CREATE(''AFLPAL'', ''LRWITHSEASONALADJUST'','''|| :schemaName ||''', ''PALLRWITHSEASONALADJUST_PROC'',PAL_FORECASTSLR_PDATA_TBL)';          SELECT COUNT(*) INTO MFSProcCount FROM OBJECTS WHERE OBJECT_NAME='PALMULTIPLEFORECASTSMOOTHING_PROC' AND SCHEMA_NAME= :schemaName;     SELECT COUNT(*) INTO LRProcCount FROM OBJECTS WHERE OBJECT_NAME='PALLRWITHSEASONALADJUST_PROC' AND SCHEMA_NAME= :schemaName;  END